#!/usr/bin/perl

use Crypt::Blowfish;

my $string = $ENV{QUERY_STRING};

# get the blowfish key
open(KEY, "</etc/asterisk/key") || die "can't open key file: $!";
chomp(my $key = <KEY>);
close(KEY);

# get a cipher from the key
$key = pack("H78", $key);
my $cipher = new Crypt::Blowfish $key;

my $text;
my @blocks = unpack("a16" x (int(length($string) / 8) + 1), $string);
foreach my $block (@blocks)
{
	last unless $block;
	$text .= $cipher->decrypt(pack("H16", $block));
	$text =~ s/[^\w\s\@\-\,\.\/\:\?\`]//g;
}
$text =~ s/\s*$//;

my ($from, $to) = split(/`/, $text);

if (!defined($from) || !defined($to))
{
	message("Unable to initiate call from '$from' to '$to'");
}

# get the number
my ($num) = ($from =~ /^(?:91|9011)?(\d+)$/);

# create a temp file -- you need to create the call file outside
# of the outgoing directory, then rename it because asterisk will
# pick up empty files WHILE you're writing to it
my $tmpfile = randstring() . ".call";

# write a call file
open(FILE, ">>/tmp/$tmpfile");
print FILE << "EOF";
Channel: $to
MaxRetries: 1
RetryTime: 60
WaitTime: 30
Context: internal
Callerid: "$num"<$num>
Extension: $from
Priority: 1
EOF
close(FILE);


rename("/tmp/$tmpfile", "/var/spool/asterisk/outgoing/$tmpfile");

message();
exit;


sub randstring
{
	my @chars = ("a".."z","A".."Z",0..9);

	my $rand;

	foreach (1 .. 12)
	{
		$rand .= $chars[int(rand(@chars))];
	}

	return $rand;
}


sub message
{
	my $message = shift;

	print << "EOF";
Content-Type: text/html

<html>
<head>
<script>
EOF

	if ($message)
	{
		print << "EOF";
alert("$message");
EOF
	}

	print << "EOF";
history.go(-1);
</script>
</head>
</html>
EOF
	exit;
}

